
#ifndef __Mod_GScript_Define__
#define __Mod_GScript_Define__

//----	߁A֐A`lAxAetc...̖̊ǗW[
;dimtype Gmd_Define_Container, 5, 1

#module	mod_gs_define \
	id, \
	name, \
	value, \
	type, \
	param, \
	attrib, \
	state

	#modinit
		mod_GetID id
		value	= 0
		type	= GSMD_DEFINE_TYPE_VALUE
		state	= GSMD_DEFINE_STATE_ENABLE
		return id

	#modfunc _gs_define_name str p_name
		name = p_name
		return
	#modfunc _gs_define_value var p_value
		value = p_value
		return
	#modfunc _gs_define_type int p_type
		type = p_type
		return
	#modfunc _gs_define_param int p_param
		param = p_param
		return
	#modfunc _gs_define_attrib int p_attrib
		attrib = p_attrib
		return
	#modfunc _gs_define_state int p_state
		state = p_state
		return

	#modcfunc _gs_define_get_name
		return name
	#modcfunc _gs_define_get_value
		return value
	#modcfunc _gs_define_get_type
		return type
	#modcfunc _gs_define_get_param
		return param
	#modcfunc _gs_define_get_attrib
		return attrib
	#modcfunc _gs_define_get_state
		return state

	#modfunc _gs_define_get_value_v var p_var
		p_var = value
		return
	#modcfunc _gs_define_get_value_ex	//	`l𕶎ŕԂAWJp
		if (type == GSMD_DEFINE_TYPE_VALUE) {
			if (vartype(value) == 1) : return ""
			if (vartype(value) == 2) : return "\""+value+"\""
			if (vartype(value) == 3) : return strf("%."+str(16-strlen(str(abs(value))))+"f",value)
		}
		if (type == GSMD_DEFINE_TYPE_CONST) {
			if (vartype(value) == 3) : return strf("%."+str(16-strlen(str(abs(value))))+"f",value)
		}
		return str(value)
#if GSMD_DEBUG
	#define global ctype	gs_define_iteminfo(%1)		_gs_define_iteminfo(Gmd_Define_Container@ModGS_Define(%1))
	#modcfunc _gs_define_iteminfo
		if (vartype(value) == 1) : return "id="+id+"\tstate["+state+"]\tname["+name+"]\tvalue[label]"+"\ttype["+type+"]\tparam["+param+"]"
		return "id="+id+"\tstate["+state+"]\tname["+name+"]\tvalue["+value+"]"+"\ttype["+type+"]\tparam["+param+"]"
#endif

#global

#define global			gs_define_create(%1)		newmod Gmd_Define_Container@ModGS_Define,mod_gs_define : _gs_define_name Gmd_Define_Container@ModGS_Define(stat), %1
/*
#define global			gs_define_delete(%1)		delmod Gmd_Define_Container@ModGS_Define(%1)
*/
#define global			gs_define_value(%1,%2)		_gs_define_value Gmd_Define_Container@ModGS_Define(%1), %2
#define global			gs_define_type(%1,%2)		_gs_define_type Gmd_Define_Container@ModGS_Define(%1), %2
#define global			gs_define_param(%1,%2)		_gs_define_param Gmd_Define_Container@ModGS_Define(%1), %2
#define global			gs_define_attrib(%1,%2)		_gs_define_attrib Gmd_Define_Container@ModGS_Define(%1), %2
#define global			gs_define_state(%1,%2)		_gs_define_state Gmd_Define_Container@ModGS_Define(%1), %2

#define global ctype	gs_define_get_name(%1)		_gs_define_get_name(Gmd_Define_Container@ModGS_Define(%1))
#define global ctype	gs_define_get_value(%1)		_gs_define_get_value(Gmd_Define_Container@ModGS_Define(%1))
#define global ctype	gs_define_get_type(%1)		_gs_define_get_type(Gmd_Define_Container@ModGS_Define(%1))
#define global ctype	gs_define_get_param(%1)		_gs_define_get_param(Gmd_Define_Container@ModGS_Define(%1))
#define global ctype	gs_define_get_attrib(%1)	_gs_define_get_attrib(Gmd_Define_Container@ModGS_Define(%1))
#define global ctype	gs_define_get_state(%1)		_gs_define_get_state(Gmd_Define_Container@ModGS_Define(%1))

#define global			gs_define_get_value_v(%1,%2)	_gs_define_get_value_v Gmd_Define_Container@ModGS_Define(%1), %2
#define global ctype	gs_define_get_value_ex(%1)	_gs_define_get_value_ex(Gmd_Define_Container@ModGS_Define(%1))



#module "ModGS_Define"
#define	GDEF_HASH_TABLE_CURRENT_COUNT	0		//	݊i[ĂnbV̐
#define	GDEF_HASH_TABLE_DELETED_COUNT	4		//	폜ꂽ瑝₵AǉɌ炷
#define	GDEF_HASH_TABLE_DATA_BEGIN		8		//	f[^ubN̎n_
#define	GDEF_HASH_TABLE_DATA_SIZE		8		//	f[^ubNTCY
#define	GDEF_HASH_TABLE_DATA_HASH		0		//	f[^ubN: nbVl
#define	GDEF_HASH_TABLE_DATA_CINDEX		4		//	f[^ubN: ReiCfbNX

	#deffunc gs_define_create_container
		dimtype Gmd_Define_Container, 5, 1
		newmod Gmd_Define_Container@ModGS_Define,mod_gs_define
		sdim str_temp	//	ėp
		return

	#deffunc gs_define_clear
		foreach Gmd_Define_Container@ModGS_Define
			delmod Gmd_Define_Container@ModGS_Define(cnt)
		loop
		newmod Gmd_Define_Container@ModGS_Define,mod_gs_define
		return
/*
	hash_table
		4byte	i[
		4byte	폜Łi낪j󂢂Ă鐔
		4byte	nbVlÂ͓o^ReiEĊmF
		4byte	o^̃ReiCfbNX
*/
	#deffunc gs_define_table_init int p_table
		sdim hash_table, 16, p_table
		hash_table_max = p_table
		hash_table_max_ = p_table-1
		return

	#deffunc gs_define_init
		if vartype(Gmd_Define_Container@ModGS_Define) == 5 {
			gs_define_clear
		} else {
			gs_define_create_container
		}
		gs_define_table_init GSMD_DEFINE_TABLE_MAX
		gs_define_create ""

		dim define_type_order_by_name, 16	//	key@name
		define_type_order_by_name(GSMD_DEFINE_TYPE_VALUE)		= 60
		define_type_order_by_name(GSMD_DEFINE_TYPE_CONST)		= 60
		define_type_order_by_name(GSMD_DEFINE_TYPE_FUNC)		= 60
		define_type_order_by_name(GSMD_DEFINE_TYPE_CFUNC)		= 60
		define_type_order_by_name(GSMD_DEFINE_TYPE_VARIABLE)	= 40
		define_type_order_by_name(GSMD_DEFINE_TYPE_SYSVAR)		= 80
		define_type_order_by_name(GSMD_DEFINE_TYPE_LABEL)		= 40
		define_type_order_by_name(GSMD_DEFINE_TYPE_PREPROCESS)	= 100

		dim define_type_order_by_key, 16	//	key
		define_type_order_by_key(GSMD_DEFINE_TYPE_VALUE)		= 50
		define_type_order_by_key(GSMD_DEFINE_TYPE_CONST)		= 50
		define_type_order_by_key(GSMD_DEFINE_TYPE_FUNC)			= 50
		define_type_order_by_key(GSMD_DEFINE_TYPE_CFUNC)		= 50
		define_type_order_by_key(GSMD_DEFINE_TYPE_VARIABLE)		= -1
		define_type_order_by_key(GSMD_DEFINE_TYPE_SYSVAR)		= 80
		define_type_order_by_key(GSMD_DEFINE_TYPE_LABEL)		= -1
		define_type_order_by_key(GSMD_DEFINE_TYPE_PREPROCESS)	= 100

		return


#if GSMD_DEBUG
	#defcfunc gs_define_info_table int p_infomask, local _blankcount, local _itemcount, local _ret
		str_temp = ""
		_ret = ""
		_count = 0
		repeat hash_table_max
			if (lpeek(hash_table(cnt), GDEF_HASH_TABLE_CURRENT_COUNT) > 0) {
				dup dup_hash_table, hash_table(cnt)
				if (p_infomask&GSMD_INFO_TABLE_LIST) : str_temp += "ID "+cnt+": "+lpeek(dup_hash_table, GDEF_HASH_TABLE_CURRENT_COUNT)+":"
				c_index = GDEF_HASH_TABLE_DATA_BEGIN
				repeat lpeek(dup_hash_table, GDEF_HASH_TABLE_CURRENT_COUNT)
					if (p_infomask&2) : str_temp += " ("+gs_define_get_name(lpeek(dup_hash_table, c_index+GDEF_HASH_TABLE_DATA_CINDEX))+"="+lpeek(dup_hash_table, c_index)+")"
					c_index+GDEF_HASH_TABLE_DATA_SIZE
					_itemcount++
				loop
				if (p_infomask&GSMD_INFO_TABLE_LIST) : str_temp += "\n"
			} else {
				_blankcount++
			}
		loop
		if (p_infomask&GSMD_INFO_TABLE_STATE) {
			_ret = "table max= "+hash_table_max+"\nuse table= "+(hash_table_max-_blankcount)+"\nblank table= "+_blankcount+"\nitem count= "+_itemcount+"\ndensity= "+(double(_itemcount) / (hash_table_max-_blankcount))+" ("+(double(_itemcount)/hash_table_max)+")"
		}
		if (p_infomask&GSMD_INFO_TABLE_LIST) {
			if (peek(str_temp,0) != 0) : _ret += "\n\n"
			_ret += str_temp
		}
		return _ret

	#defcfunc gs_define_info int p_infomask, local _type
		sdim str_temp, 4096
		foreach Gmd_Define_Container@ModGS_Define
			if (p_infomask > -1) {
				_type = gs_define_get_type(cnt)
				if (_type == GSMD_DEFINE_TYPE_VALUE)		: if ((p_infomask&GSMD_INFO_DEFINE_VALUE) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_CONST)		: if ((p_infomask&GSMD_INFO_DEFINE_CONST) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_FUNC)			: if ((p_infomask&GSMD_INFO_DEFINE_FUNC) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_CFUNC)		: if ((p_infomask&GSMD_INFO_DEFINE_CFUNC) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_VARIABLE)		: if ((p_infomask&GSMD_INFO_DEFINE_VARIABLE) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_SYSVAR)		: if ((p_infomask&GSMD_INFO_DEFINE_SYSVAR) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_LABEL)		: if ((p_infomask&GSMD_INFO_DEFINE_LABEL) == 0) : continue
				if (_type == GSMD_DEFINE_TYPE_PREPROCESS)	: if ((p_infomask&GSMD_INFO_DEFINE_PREPROCESS) == 0) : continue
			}
			str_temp += gs_define_iteminfo(cnt)+"\n"
		loop
		return str_temp

	;#define global ctype gsi_Define(%1=255)		gs_define_info(%1)
	;#define global ctype gsi_Table(%1=3)		gs_define_info_table(%1)
	#define global ctype gsc_info_Define(%1=255)	gs_define_info(%1)
	#define global ctype gsc_info_Table(%1=3)		gs_define_info_table(%1)
#endif
/*
	#defcfunc gs_define_hash str p_key
		str_temp = p_key
		hash_value = 0
		repeat strlen(str_temp) : hash_value = hash_value * 137 + peek(str_temp,cnt) : loop
		return hash_value
*/
	#deffunc _gs_define_search str p_key
		if (p_key == "") {
			container_index = 0
			return 0
		}
		;hash_value = gs_define_hash(p_key)
		str_temp = p_key
		hash_value = 0
		repeat strlen(str_temp) : hash_value = hash_value * 137 + peek(str_temp,cnt) : loop
		
		hash_index = hash_value & hash_table_max_	//	hash_index = (abs(hash_value) \ hash_table_max)
		container_index = 0
		c_index = GDEF_HASH_TABLE_DATA_BEGIN
		list_item = lpeek(hash_table(hash_index), GDEF_HASH_TABLE_CURRENT_COUNT)
		repeat list_item
			if (lpeek(hash_table(hash_index), c_index) == hash_value) {
				container_index = lpeek(hash_table(hash_index), c_index+GDEF_HASH_TABLE_DATA_CINDEX)
				if (gs_define_get_name(container_index) == p_key) {
					break
				}
				container_index = 0
			}
			c_index + GDEF_HASH_TABLE_DATA_SIZE
		loop
		if container_index {
			if (gs_define_get_state(container_index) & GSMD_DEFINE_STATE_MASK_ENABLE) == GSMD_DEFINE_STATE_DISABLE {
				container_index *= -1
			}
		}
		return container_index



	#deffunc _gs_define_search2 str p_key, str p_name	//	key  key@name ŌB keŷ݂D悳
		_gs_define_search p_key
		if stat : return
		if (p_name == "") : return
		_gs_define_search p_key+"@"+p_name
		return

	//	nꂽ p_key 肵A p_key ɐ̂AstatɌ^Ԃ
	//	RpC̕ϐ͈ꎞIȂ̂ł邽߁Aϐ͓̐̂Ȃ
	#deffunc _gs_define_identify var p_key, str p_name, local _key, local _type1, local _type2
		if instr(p_key, 0, "@") == -1 {
			//	@
	
			//	key Ō
			_gs_define_search p_key
			_type1 = stat
			if (p_name == "") : return _type1	//	Ԗ΂̂܂ܕԂ

			//	key@name Ō
			_gs_define_search p_key+"@"+p_name
			_type2 = stat
			//	key@nameꍇkeyԂ
			if (_type2 == 0) {
				return _type1
			}
			//	keyꍇkey@naměʂԂ
			if (_type1 == 0) {
				p_key += "@"+p_name
				return _type2
			}

			//	ǂʂLȂ̂Ŕr
			if define_type_order_by_name(gs_define_get_type(abs(_type2))) > define_type_order_by_key(gs_define_get_type(abs(_type1))) {
				//	key@name
				p_key += "@"+p_name
				return _type2
			} else {
				//	key
				return _type1
			}
		} else {
			//	@L
			if (instr(p_key, 0, "@") == (strlen(p_key)-1)) {
				//	O[ow
				poke p_key, strlen(p_key)-1, 0
				_gs_define_search p_key
				return
			} else {
				//	OԎw
				_gs_define_search p_key
				return
			}
		}
		return 0



	#deffunc _gs_define_add str p_key, var p_value
		_gs_define_search p_key
		if (container_index == 0) {
			//	VKǉ
			gs_define_create p_key : container_index = stat : list_item++
			if (lpeek(hash_table(hash_index), GDEF_HASH_TABLE_DELETED_COUNT) == 0) {
				//	폜ꂽvfꍇ͒ǉmۂ
				memexpand hash_table(hash_index), list_item*GDEF_HASH_TABLE_DATA_SIZE+16
			} else {
				//	Lꍇ͊mۂ̕KvA폜JE^
				lpoke hash_table(hash_index), GDEF_HASH_TABLE_DELETED_COUNT, lpeek(hash_table(hash_index), GDEF_HASH_TABLE_DELETED_COUNT)-1
			}
			lpoke hash_table(hash_index), c_index, hash_value
			lpoke hash_table(hash_index), c_index+4, container_index
			lpoke hash_table(hash_index), GDEF_HASH_TABLE_CURRENT_COUNT, list_item
		} else {
			container_index = abs(container_index)
		}
		gs_define_value container_index, p_value
		return container_index

	#deffunc _gs_define_delete str p_key
		_gs_define_search p_key
		if (container_index == 0) : return -1
		container_index = abs(container_index)
		;gs_define_delete container_index
		delmod Gmd_Define_Container@ModGS_Define(container_index)
		del_item = (c_index - GDEF_HASH_TABLE_DATA_BEGIN) / GDEF_HASH_TABLE_DATA_BEGIN + 1	//	1 ~ list_item ͈̔͂Ŏ擾Ă
		if (del_item != list_item) {		//	_gs_define_searchlist_itemɑĂ̂Ŕr
			//	ŌłȂ̂ŋl߂AŌEĂČ߂lǒǉێĂ
			p = (list_item - del_item)*GDEF_HASH_TABLE_DATA_SIZE
			sdim str_temp, p+4
			memcpy str_temp, hash_table(hash_index), p, 0, del_item*GDEF_HASH_TABLE_DATA_SIZE+8
			del_item--
			memcpy hash_table(hash_index), str_temp, p, del_item*GDEF_HASH_TABLE_DATA_SIZE+8, 0
		}
		lpoke hash_table(hash_index), GDEF_HASH_TABLE_CURRENT_COUNT, list_item-1
		lpoke hash_table(hash_index), GDEF_HASH_TABLE_DELETED_COUNT, lpeek(hash_table(hash_index), GDEF_HASH_TABLE_DELETED_COUNT)+1
		return 0

	#deffunc gs_define_clear_temporary local _type
		foreach Gmd_Define_Container@ModGS_Define
			_type = gs_define_get_type(cnt)
			if (_type != GSMD_DEFINE_TYPE_CONST) && (_type != GSMD_DEFINE_TYPE_TEMPVAR) && (_type != GSMD_DEFINE_TYPE_TEMPREFLABEL) && (_type != GSMD_DEFINE_TYPE_TEMPLABEL) : continue
			if (gs_define_get_attrib(cnt) == GSMD_DEFINE_ATTRIBUTE_TEMP) {
				_gs_define_delete gs_define_get_name(cnt)
			}
		loop
		return

	#deffunc gs_define_enable_all
		foreach Gmd_Define_Container@ModGS_Define
			gs_define_state cnt, (gs_define_get_state(cnt)^GSMD_DEFINE_STATE_MASK_ENABLE) | GSMD_DEFINE_STATE_ENABLE
		loop
		return

	#deffunc gs_define_enable str p_key
		_gs_define_search p_key
		if (container_index == 0) : return -1
		container_index = abs(container_index)
		gs_define_state container_index, (gs_define_get_state(cnt)^GSMD_DEFINE_STATE_MASK_ENABLE) | GSMD_DEFINE_STATE_ENABLE
		return container_index

	#deffunc gs_define_disable str p_key
		_gs_define_search p_key
		if (container_index == 0) : return -1
		container_index = abs(container_index)
		gs_define_state container_index, (gs_define_get_state(cnt)^GSMD_DEFINE_STATE_MASK_ENABLE) | GSMD_DEFINE_STATE_DISABLE
		return container_index

	#deffunc gs_define_enable_list str p_key, local _strsrc, local _strlist, local _strcount
		_strsrc = p_key
		_strsrc = strtrim( _strsrc, 3, ' ')
		_strsrc = strtrim( _strsrc, 3, '\t')
		sdim _strlist
		split _strsrc, ",", _strlist : _strcount = stat
		repeat _strcount : gs_define_enable _strlist(cnt) : loop
		return

	#deffunc gs_define_disable_list str p_key, local _strsrc, local _strlist, local _strcount
		_strsrc = p_key
		_strsrc = strtrim( _strsrc, 3, ' ')
		_strsrc = strtrim( _strsrc, 3, '\t')
		sdim _strlist
		split _strsrc, ",", _strlist : _strcount = stat
		repeat _strcount : gs_define_disable _strlist(cnt) : loop
		return




#define global gs_define_add(%1,%2)				_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp	//	GSMD_DEFINE_TYPE_VALUE
#define global gs_define_delete(%1)				_gs_define_delete getpath(%1,16)

#define global gs_define_search(%1)				_gs_define_search %1
#define global gs_define_searchf(%1)			_gs_define_search getpath(%1,16)
#define global gs_define_search2(%1,%2="")		_gs_define_search2 %1,%2
#define global gs_define_searchf2(%1,%2="")		_gs_define_search2 getpath(%1,16),getpath(%2,16)

#define global gs_define_identify(%1,%2="")		_gs_define_identify %1,%2
#define global gs_define_identifyf(%1,%2="")	_gs_define_identify getpath(%1,16),getpath(%2,16)


#define global gs_define_add_const(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_CONST:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_SYSTEM
#define global gs_define_add_func(%1,%2,%3)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_FUNC:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_SYSTEM:gs_define_param stat,%3
#define global gs_define_add_cfunc(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_CFUNC:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_SYSTEM
#define global gs_define_add_variable(%1,%2)	_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_VARIABLE
#define global gs_define_add_label(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_LABEL
#define global gs_define_add_preprocess(%1,%2)	_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_PREPROCESS:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_SYSTEM
#define global gs_define_add_sysvar(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_SYSVAR:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_SYSTEM

#define global gs_define_user_define(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_CONST:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_USER
#define global gs_define_temp_define(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_CONST:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_TEMP

#define global gs_define_tempvar(%1,%2)			_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_TEMPVAR:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_TEMP
#define global gs_define_tempreflabel(%1,%2)	_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_TEMPREFLABEL:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_TEMP
#define global gs_define_templabel(%1,%2)		_temp@ModGS_Temp=%2:_gs_define_add getpath(%1,16),_temp@ModGS_Temp:gs_define_type stat,GSMD_DEFINE_TYPE_TEMPLABEL:gs_define_attrib stat,GSMD_DEFINE_ATTRIBUTE_TEMP

#global

gs_define_init

#define global gsc_Define(%1,%2)		gs_define_add %1, %2
#define global gsc_Define2(%1,%2)		gs_define_add_const %1, %2
#define global gsc_Undef(%1)			gs_define_delete %1

#define global gsc_define_EnableALL		gs_define_enable_all
#define global gsc_define_Enable(%1)	gs_define_enable getpath(%1,16)
#define global gsc_define_Disable(%1)	gs_define_disable getpath(%1,16)

#define global gsc_define_EnableList(%1)	gs_define_enable_list getpath(%1,16)
#define global gsc_define_DisableList(%1)	gs_define_disable_list getpath(%1,16)

#endif
