
#ifndef __Mod_GScript_Label__
#define __Mod_GScript_Label__

//---- xǗW[
#module	mod_gs_label \
	id, \
	code, \
	address, \
	name, \
	flag

	#modinit
		mod_GetID id
		code	= 0
		address	= 0
		name	= ""
		flag	= 0
		return id

	#modterm
		return

	#modfunc _gs_label_add	str p_name, int p_code, int p_addr, int p_flag
		code	= p_code
		address	= p_addr
		name	= p_name
		if (p_flag & 1) {
			flag	= p_flag
		}
		return

	#modcfunc _gs_label_get_code
		return code
	#modcfunc _gs_label_get_address
		return address
	#modcfunc _gs_label_get_name
		return name
	#modcfunc _gs_label_get_flag
		return flag
#global

#module "ModGS_Label"

	#deffunc gs_label_create_container
		dimtype Gmd_Label_Container, 5, 1
		return

	#deffunc gs_label_clear
		foreach Gmd_Label_Container@ModGS_Label
			gs_define_delete _gs_label_get_name(Gmd_Label_Container@ModGS_Label(cnt))
			delmod Gmd_Label_Container@ModGS_Label(cnt)
		loop
		return

	#deffunc gs_label_init
		if vartype(Gmd_Label_Container@ModGS_Label) == 5 {
			gs_label_clear
		} else {
			gs_label_create_container
		}
		newmod Gmd_Label_Container@ModGS_Label, mod_gs_label
		return

	#defcfunc gs_label_search str p_name, local id
		gs_define_searchf p_name
		id = abs(stat)
		if (id) {
			if (gs_define_get_type(id) == GSMD_DEFINE_TYPE_LABEL) {
				id = gs_define_get_value(id)
			} else {
				id = -1
			}
		} else {
			id = -1
		}
		return id

	#deffunc gs_label_add	str p_name, int p_code, int p_address, int p_flag, local id
		id = gs_label_search(p_name)
		if (id == -1) {	//	o^
			newmod Gmd_Label_Container@ModGS_Label, mod_gs_label
			id = stat
		}
		_gs_label_add Gmd_Label_Container@ModGS_Label(id), p_name, p_code, p_address, p_flag
		gs_define_add_label p_name, id
		return id

	#deffunc gs_label_delete_by_code int p_code
		foreach Gmd_Label_Container@ModGS_Label
			if _gs_label_get_code(Gmd_Label_Container@ModGS_Label(cnt)) == p_code {
				gs_define_delete _gs_label_get_name(Gmd_Label_Container@ModGS_Label(cnt))
				delmod Gmd_Label_Container@ModGS_Label(cnt)
			}
		loop
		return
	
	#define	global ctype	gs_label_get_code(%1)			_gs_label_get_code(Gmd_Label_Container@ModGS_Label(%1))
	#define	global ctype	gs_label_get_address(%1)		_gs_label_get_address(Gmd_Label_Container@ModGS_Label(%1))
	#define	global ctype	gs_label_get_name(%1)			_gs_label_get_name(Gmd_Label_Container@ModGS_Label(%1))
	#define	global ctype	gs_label_get_flag(%1)			_gs_label_get_flag(Gmd_Label_Container@ModGS_Label(%1))
	#define global ctype	gs_label_varuse(%1)				varuse(Gmd_Label_Container@ModGS_Label(%1))

#global

gs_label_init

#define global			gsc_label_GetCodeID			gs_label_get_code
#define global			gsc_label_GetAddress		gs_label_get_address
#define global			gsc_label_GetName			gs_label_get_name
#define global			gsc_label_Exist				gs_label_varuse
#define global ctype	gsc_label_GetLabelID(%1)	gs_label_search(%1)

#endif
