
;#define global GSMD_LOG 1

#ifndef __Mod_GScript_Log__
#define __Mod_GScript_Log__

#module "ModGS_Log"

#if GSMD_LOG = 0

	#define global gsc_log_Reset :
	#define global gs_log_init :

	#define global gsc_log_Enable :
	#define global gsc_log_Disable :

	#define global gsc_log_Push :
	#define global gs_log_push :

	#define global gsc_log_Write(%1) :
	#define global gs_log_write(%1) :

	#define global ctype gsc_log_GetRecordNum	gs_log_get_record_num()
	#defcfunc gs_log_get_record_num
		return 0
	
	#define global ctype gsc_log_GetSize	gs_log_get_size()
	#defcfunc gs_log_get_size
		return 0

	#define global ctype gsc_log_GetLog(%1=-1,%2=-1)	gs_log_read(%1,%2)
	#defcfunc gs_log_read int p_first, int p_last
		return ""

	#define global gsc_log_Delete(%1=-1,%2=-1) :

#else

	//	
	#define global gsc_log_Reset	gs_log_init
	#deffunc gs_log_init
	
		Debug_Log_Flag@ModGS_Log = 1	//	0=disable, 1=enable

		sdim Debug_Log_String, 65536	//	O{
		Debug_Log_Index = 0				//	݈ʒu
		Debug_Log_Max = 65536			//	{̍őTCY

		sdim Debug_Record_List, 65536	//	eR[h̐擪CfbNX
		Debug_Record_Index = 0			//	R[h̃CfbNX
		Debug_Record_Max = 16384		//	R[hő吔
	
		sdim temp_str					//	ėp
		temp_len = 0

		return

	#define global gsc_log_Enable	Debug_Log_Flag@ModGS_Log=1
	#define global gsc_log_Disable	Debug_Log_Flag@ModGS_Log=0

	//	R[hvbV
	#define global gsc_log_Push	gs_log_push
	#define global gs_log_Push	if Debug_Log_Flag@ModGS_Log { _gs_log_push }
	#deffunc _gs_log_push
		Debug_Record_Index++
		if Debug_Record_Index >= Debug_Record_Max {
			Debug_Record_Max += 16384
			memexpand Debug_Record_List, Debug_Record_Max*4
		}
		lpoke Debug_Record_List, Debug_Record_Index*4, Debug_Log_Index
		return

	//	
	#define global gsc_log_Write	gs_log_write
	#define global gs_log_Write(%1)	if Debug_Log_Flag@ModGS_Log { _gs_log_write %1 }
	#deffunc _gs_log_write str p_string
		temp_str = p_string+"\n" : temp_len = strlen(temp_str)
		*@
		if (Debug_Log_Index + temp_len) >= Debug_Log_Max {
			Debug_Log_Max += 65536
			memexpand Debug_Log_String, Debug_Log_Max
			goto *@b
		}
		memcpy Debug_Log_String, temp_str, temp_len, Debug_Log_Index, 0
		Debug_Log_Index += temp_len
		return

	//	R[hԂ
	#define global ctype gsc_log_GetRecordNum	gs_log_get_record_num()
	#defcfunc gs_log_get_record_num
		return Debug_Record_Index

	//	ÕTCYԂ
	#define global ctype gsc_log_GetSize	gs_log_get_size()
	#defcfunc gs_log_get_size
		return Debug_Log_Index

	//	Cӂ͈̔͂̃OԂ
	//	p_first		-1: 擪
	//	p_last		-1:	Ō
	//
	#define global ctype gsc_log_GetLog(%1=-1,%2=-1)	gs_log_read(%1,%2)
	#defcfunc gs_log_read int p_first, int p_last, local __first, local __last, local __subsize
		if p_first < 0 {
			__first = 0
		} else {
			if p_first > Debug_Record_Index : return ""
			__first = lpeek(Debug_Record_List, p_first*4)
		}
		if p_last < 0 {
			__last = Debug_Log_Index
		} else {
			if p_last < p_first : return ""
			if p_last >= Debug_Record_Index {
				__last = Debug_Log_Index
			} else {
				__last = lpeek(Debug_Record_List, (p_last+1)*4)
			}
		}
		__subsize = __last-__first
		sdim temp_str, __subsize+1
		if __last >= 2 {
			if wpeek(Debug_Log_String, __last-2) == 2573 {	//	\n
				__subsize -= 2
			}
		}
		if __subsize > 0 {
			memcpy temp_str, Debug_Log_String, __subsize, 0, __first
		}
		return temp_str

	#define global gsc_log_Delete(%1=-1,%2=-1)	gs_log_delete %1,%2
	#deffunc gs_log_delete int p_first, int p_last, local __first, local __last, local __recordnum, local __delsize, local __offset, local __subsize
		if p_first < 0 {
			__first = 0
		} else {
			if p_first > Debug_Record_Index : return 0
			__first = p_first
		}
		if p_last < 0 {
			__last = Debug_Record_Index
		} else {
			if p_last < p_first : return 0
			if p_last >= Debug_Record_Index {
				__last = Debug_Record_Index
			} else {
				__last = p_last
			}
		}
		__recordnum = __last-__first+1	//	폜郌R[h
		__offset = lpeek(Debug_Record_List, __first*4)	//	폜JnItZbg
		if __last != Debug_Record_Index {
			__delsize = lpeek(Debug_Record_List, (__last+1)*4) - __offset	//	폜TCY
		} else {
			__delsize = Debug_Log_Index - __offset
		}

		__subsize = Debug_Log_Index - (__offset+__delsize)	//	[ log2 ] del [ log2 ] Ƃꍇ log2 ̃TCY
		if __subsize >= 0 {	//	Öړ
			sdim temp_str, __subsize	//	[ log2 ] del [ log2 ] -> [ log2 ] [ log2 ] ̏ԂɂA̓NAKvȂ
			memcpy temp_str, Debug_Log_String, __subsize, 0, __offset+__delsize
			memcpy Debug_Log_String, temp_str, __subsize, __offset, 0
			Debug_Log_Index -= __delsize
		}

		__subsize = Debug_Record_Index - __last
		if __subsize >= 0 {	//	R[ḧړ
			sdim temp_str, __subsize*4
			memcpy temp_str, Debug_Record_List, __subsize*4, 0, (__first+__recordnum)*4
			memcpy Debug_Record_List, temp_str, __subsize*4, __first*4, 0
			repeat __subsize
				lpoke Debug_Record_List, (__first+cnt)*4, lpeek(Debug_Record_List, (__first+cnt)*4)-__delsize
			loop
			Debug_Record_Index -= __recordnum
		}
		return __recordnum


#endif

/*
	#define global gsl_Reset		gsc_log_Reset
	#define global gsl_Push			gsc_log_Push
	#define global gsl_Write		gsc_log_Write
	#define global gsl_GetRecordNum	gsc_log_GetRecordNum
	#define global gsl_GetLog		gsc_log_GetLog
*/

#global
gs_log_Init
#endif

#if 0
	sysfont 17

	repeat 10,1
		gsc_log_Push
		gsc_log_Write "logtest-arg("+cnt+")"
	loop

	gsc_log_Push
	gsc_log_Write "hogepiyo"

	gsc_log_Push
	gsc_log_Write "foobar"

	pos 10,10
	mes "record="+gsc_log_GetRecordNum()
	repeat gsc_log_GetRecordNum() : mes ""+cnt+":"+gsc_log_GetLog(cnt,cnt) : loop

	gsc_log_Delete 3,6	//	3,4,5,6  4폜

	pos 160,10
	mes "record="+gsc_log_GetRecordNum()
	repeat gsc_log_GetRecordNum() : mes ""+cnt+":"+gsc_log_GetLog(cnt,cnt) : loop

	gsc_log_Push
	gsc_log_Write "apple"

	gsc_log_Push
	gsc_log_Write "orange"

	pos 320,10
	mes "record="+gsc_log_GetRecordNum()
	repeat gsc_log_GetRecordNum() : mes ""+cnt+":"+gsc_log_GetLog(cnt,cnt) : loop

#endif