
#ifndef __Mod_GScript_Misc__
#define __Mod_GScript_Misc__

#module "ModGS_Misc"



	//	gs_strmod
	#defcfunc gsc_GetStringLength str p_str, int p_enc, local _str, local _len, local _count, local _index
		_str = p_str
		_len = strlen(_str)
		_count = 0
		_index = 0
		repeat _len
			_count++ : _index += gs_strmod_GetIndexByte( _str, _index, p_enc) : if _index >= _len : break
		loop
		return _count

	#defcfunc gsc_GetStringIndexBytes str p_str, int p_index, int p_enc, local _str
		_str = p_str
		return gs_strmod_GetIndexByte(_str, p_index, p_enc)

	#defcfunc gsc_GetStringBytes str p_str, int p_index, int p_enc, local _str
		_str = p_str
		return gs_strmod_GetCharByte(_str, p_index, p_enc)

	#defcfunc gsc_GetPreviousStringBytes str p_str, int p_index, int p_enc, local _str
		_str = p_str
		return gs_strmod_GetPreviousCharByte(_str, p_index, p_enc)

	#defcfunc gsc_GetBufferLength var p_str, int p_enc, local _len, local _count, local _index
		_len = strlen(p_str)
		_count = 0
		_index = 0
		repeat _len
			_count++ : _index += gs_strmod_GetIndexByte( p_str, _index, p_enc) : if _index >= _len : break
		loop
		return _count

	#define global ctype gsc_GetBufferIndexBytes(%1,%2,%3=0) gs_strmod_GetIndexByte(%1,%2,%3)

	#define global ctype gsc_GetBufferBytes(%1,%2,%3=0) gs_strmod_GetCharByte(%1,%2,%3)
	;#defcfunc gsc_GetBufferBytes var p_var, int p_index, int p_enc
	;	return GetCharByte(p_var, p_index, p_enc)

	#define global ctype gsc_GetPreviousBufferBytes(%1,%2,%3=0) gs_strmod_GetPreviousCharByte(%1,%2,%3)
	;#defcfunc gsc_GetBufferBytes var p_var, int p_index, int p_enc
	;	return GetCharByte(p_var, p_index, p_enc)
	
	#define global gsc_RemoveSpace(%1,%2,%3=0)	gs_strmod_removespace %1,%2,%3

	//	gs_calculate
	#define global gsc_Bin2Dec		gs_calculate_bin2dec
	#define global gsc_Dec2Bin		gs_calculate_dec2bin
	#define global gsc_GetBitCount	gs_calculate_getbitcount
	#define global gsc_GetMSB		gs_calculate_getmsb
	#define global gsc_GetLSB		gs_calculate_getlsb
	
	//	gs_compile
	#define global gsc_FormatPath	gs_compile_format_path
	
#global

#endif
